## Arabic-plate-recognition

import plate_detection as pd
import character_recognition as cr
import cv2
import glob
import os
import commonfunctions as cf

# clear the output folder
files = glob.glob('outputPlateDetection/*')
for f in files:
  os.remove(f)
# read all the images from the folder
for imgName in sorted(glob.glob('AllWorking/*.jpg')):
  car = cv2.imread(imgName)
  # Detect the plate in the image
  to_be_modified_plate=pd.plate_detection(car)
  # If no plate is detected, continue to the next image
  if to_be_modified_plate is None:
    continue
  to_be_modified_plate = cv2.cvtColor(to_be_modified_plate, cv2.COLOR_GRAY2BGR)
  # If the plate is detected, then process it
  last_plate_processed=pd.plate_detection(to_be_modified_plate, True)
  # If the plate is not processed, continue to the next image
  if last_plate_processed is None:
    continue
  # Save the processed plate
  imgName = "outputPlateDetection/"+imgName.split('\\')[1]
  check = cv2.imwrite(imgName, last_plate_processed)
  cv2.imwrite('outputPlateDetection/'+imgName, last_plate_processed) 

#### Character segmentation and recognition ####
i=0
for imgName in sorted(glob.glob('outputPlateDetection/*.jpg')):

    plateImage=cv2.imread(imgName)
    plateImage=cv2.cvtColor(plateImage,cv2.COLOR_BGR2GRAY)
    
    txt = cr.readPlate2(plateImage)
    if txt !="":
        cf.show_images([plateImage])
        print("Plate Number :  " + txt)