import cv2
import pytesseract
from readdataset import *
import numpy as np
from servoo import *

#servo object
obj_servo = servo_class()
#dataset object
obj = checkPlates()
found_plates = obj.read_csv_file()


cap = cv2.VideoCapture(1)
while cap.isOpened():
    ret, frame = cap.read()
    gray_image = cv2.cvtColor(frame, cv2.COLOR_BGR2GRAY)
    canny_edge = cv2.Canny(gray_image, 170, 200)
    contours, new  = cv2.findContours(canny_edge, cv2.RETR_LIST, cv2.CHAIN_APPROX_SIMPLE)
    contours=sorted(contours, key = cv2.contourArea, reverse = True)


    license_plate, plate_number = None,None
    x,y,w,h = None,None,None,None


    for contour in contours:
            perimeter = cv2.arcLength(contour, True)
            approx = cv2.approxPolyDP(contour, 0.01 * perimeter, True)
            if len(approx) == 4: 
                license_plate = approx
                x, y, w, h = cv2.boundingRect(contour)
                plate_number = gray_image[y:y + h, x:x + w]
                break
    try:
        plate_number = cv2.bilateralFilter(plate_number, 11, 17, 17)

        (thresh, plate_number) = cv2.threshold(plate_number, 150, 180, cv2.THRESH_BINARY)


        text = pytesseract.image_to_string(plate_number)

        print(found_plates)

        
        for i in found_plates:
            if i in text:
                
                print("Found it ^_^", i)
                obj.historyy(i)
                obj_servo.runServo()
                break
        
        frame = cv2.rectangle(frame, (x,y), (x+w,y+h), (0,0,255), 3) 
        frame = cv2.putText(frame, text, (x-100,y-50), cv2.FONT_HERSHEY_SIMPLEX, 1, (0,0,255), 3)

        print("Plate Number:", text)

        cv2.imshow("Plate",frame)
        if cv2.waitKey(1) == 27:
            break
            
    except:
        pass

